<script>
    import { secondsPerPixel } from '../stores/layoutStore.js';
    import { arc } from 'd3';
    export let plotElement;
    export let xScale;
    export let yScale;

    function checkError(response) {
        if (response.status >=200 && response.status <= 299) {
            return response.json();
        } else {
            throw Error(response.statusText)
        }
    }

    export const loadSymbolData = async function(url) {
        let jsondata_out = {};
        await fetch(url)
            .then((response) => {
                return checkError(response);
            }).then((jsondata) => {
                jsondata_out = jsondata;
            }).catch((error) => {
                console.log("Error getting symbol data: " + error);
            });
        return jsondata_out;
    }

    let url = plotElement.server + '/' + plotElement.dataset;
    let dataPromise = loadSymbolData(url);
</script>

{#await dataPromise}
{:then data}
    {#each data['lines'] as linedata}
        <line x1={xScale(new Date(linedata['x1']))}
              x2={xScale(new Date(linedata['x2']))}
              y1={yScale(linedata['y1'])}
              y2={yScale(linedata['y2'])}
              stroke={linedata['stroke-color']}
              stroke-width={linedata['stroke-width']}/>
    {/each}
    {#each data['arcs'] as arcdata}
        <path d={arc()
                    .innerRadius(arcdata['innerRadius'])
                    .outerRadius(arcdata['outerRadius'])
                    .startAngle(arcdata['startAngle'])
                    .endAngle(arcdata['endAngle'])()
                    }
              transform="translate( {xScale(new Date(arcdata.x))}, {yScale(0)})"
              fill={arcdata['fill']}
              stroke={arcdata['stroke-color']}
              stroke-width={arcdata['stroke-width']}/>
    {/each}
    {#if ($secondsPerPixel < 150)}
        {#each data['texts'] as textdata}
            <text x={xScale(new Date(textdata['x']))}
                  y={yScale(textdata['y'])}
                  transform="translate({textdata['xshift']},{textdata['yshift']})"
                  style="text-anchor: {textdata['text-anchor']};
                         dominant-baseline: {textdata['dominant-baseline']};
                         font-size: 11px;">{textdata['text']}</text>

        {/each}
    {/if}
{:catch error}
    <p style="color: red">{error.message}</p>
{/await}

<style>

</style>
